//***************************************************************************
//
//  ̧......: main.c
//  ......: ATMEL Norway
//  Ώ......: ATmega169
//  ߲....: IAR EWAAVR 2.28a
//  e......: AVR Butterfly ٰ
//  Ŕԍ....: 1.0
//
//  N   - VER. - 											- 
//  20030116 - 1.0  - 쐬											- KS
//
//***************************************************************************

#include <inavr.h>

#include "iom169.h"
#include "main.h"
#include "LCD_functions.h"
#include "LCD_driver.h"
#include "button.h"
#include "RTC.h"
#include "timer0.h"
#include "BCD.h"
#include "usart.h"
#include "sound.h"
#include "ADC.h"
#include "dataflash.h"
//#include "eeprom.h"
#include "test.h"
#include "vcard.h"
#include "menu.h"

#define pLCDREG_test (*(char *)(0xEC))							// LCDDRʒu

/* ϐ` */

extern __flash unsigned int LCD_character_table[];				// ˾Ēlϊ\
extern char gPowerSaveTimer;									// ȓd͈ڍsԌvl (RTC.cŌv)
char PowerSaveTimeout = 30;										// ȓd͈ڍs(l=30)
BOOL AutoPowerSave = TRUE;										// ȓd͈ڍsON/OFF׸
char gAutoPressJoystick = FALSE;								// ͌JԂ׸(FALSE=~,AUTO=Ԋu,TRUE=ON)
char PowerSave = FALSE;											// ȓd͓/ʏ퓮׸
char gPlaying = FALSE;											// ȍĐON/OFF׸(Đ̏ȓd͈ڍsh~Ɏgp:sound.c)
char gUART = FALSE;												// USARTgp׸(gp̏ȓd͈ڍsh~Ɏgp:vcard.c)
unsigned char state;											// menu.hŒ`ꂽ݂̏Ԕԍ

//*****************************************************************************
//*
//*	֐	: main
//*		: Ȃ
//*	߂l	: Ȃ
//*	ړI	: JԂ
//*
//*****************************************************************************

__C_task void main(void)
{    
//	unsigned char state, nextstate;
	unsigned char nextstate;									// Ԕԍ
	static char __flash *statetext;								// Ήƭ߲
	char (*pStateFunc)(char);									// s߲
	char input;													// ޮèԔԍ
	char i;														// Ɨp
	char buttons;												// ޮè Ԓl
	char last_buttons;											// O̼ޮè Ԓl

	/* Ԋ֌Wl */
	state = nextstate = ST_AVRBF;								// Ԕԍ
	statetext = MT_AVRBF;										// ƭ߲
	pStateFunc = NULL;											// s߲
    /* ۸ъ֌W */
	Initialization();											// e
	__enable_interrupt();										// S荞݋
	/* 又 */
	for (;;)
	{
		if(!PowerSave)											/* ʏ퓮(ȓd͓ȊO) */
		{
			/* ƭs */
			if (statetext)										/* (ƭL) */
			{
				LCD_puts_f(statetext, 1);						// ΉƭLCDޯ̧]
				LCD_Colon(0);									// LCD(:)\OFFݒ
				statetext = NULL;								// ƭȂݒ
			}

			input = getkey();									// ޮèԔԍ擾
			if (pStateFunc)										// sȂA
			{
				nextstate = pStateFunc(input);					// ΉssԔԍ擾
			}
			else if (input != KEY_NULL)							// ޮèꂩ̽ONȂA
			{
				nextstate = StateMachine(state, input);			// ԑJڌԔԍ擾
			}
			if (nextstate != state)								/* (ԔԍvύX) */
			{
				state = nextstate;								// ԔԍXV
				for (i=0; menu_state[i].state; i++)				/* (( ƭ/sʒu擾)) */
				{
					if (menu_state[i].state == state)			// ΉԔԍvȂA
					{
						statetext =  menu_state[i].pText;		// Ήƭ擪ʒu擾
						pStateFunc = menu_state[i].pFunc;		// Ήs擪ʒu擾
						break;									// I
					}
				}
			}
		}
		/* ȓd͈ڍsԏ */
		if(AutoPowerSave)										/* ȓd͈ڍsON */
		{
			if(gPowerSaveTimer >= PowerSaveTimeout)				// ȓd͈ڍsԌo߂ȂA
			{
				state = ST_AVRBF;								// Ԕԍ
				gPowerSaveTimer = 0;							// ȓd͈ڍsԌvl
				PowerSave = TRUE;								// ȓd͓׸ސݒ(ʏ퓮׸މ)
			}
		}
		/*  */
		if( !(PINB & (1<<PORTB7)) && !(PINB & (1<<PORTB6)) )	// Ɓ̽ONŎs
			Test();
		/* ޮè pON̎JԂ */
		buttons = (~PINB) & PINB_MASK;							// ߰B_l擾
		buttons |= (~PINE) & PINE_MASK;							// ߰E_l܂ݑSl擾
		if(buttons != last_buttons)								/* ԕω */
		{
			last_buttons = buttons;								// 񽨯lۑ
			gAutoPressJoystick = FALSE;							// ͌JԂ׸މ(~ݒ)
		}
		else if(buttons)										/* Ԗωꂩ̽ON */
		{
			if(gAutoPressJoystick == TRUE)						// JԂԊuo߂ȂA
			{
				PinChangeInterrupt();							// ԍĎ擾
				gAutoPressJoystick = AUTO;						// JԂԊuvݒ
			}
			else												// JԂ~܂͊ԊuvȂA
				gAutoPressJoystick = AUTO;						// JԂԊuvݒ
		}
        /* ȓd͓֌W */
		if(!gPlaying && !gUART)									/* ȍĐUSARTgpȂ */
		{
			if(PowerSave)										// ȓd͓ȂA
				cbi(LCDCRA, 7);									// LCD֎~
			SMCR = (3<<SM0) | (1<<SE);							// ܰޓŽذߖߋ
			__sleep();											// ܰ ذߓڍs

			if(PowerSave)										/* ȓd͓쎞 */
			{
				if(!(PINB & 0x40))								/* (ł̋N) */
				{
					PowerSave = FALSE;							// ʏ퓮׸ސݒ(ȓd͓׸މ)
					for(i = 0; i < 20; i++)						/* ((LCDDRSĒlݒ)) */
					{
						*(&pLCDREG_test + i) = 0x00;			// ΉLCDDRSĒlݒ
					}
                    
					sbi(LCDCRA, 7);								// LCDċ
					input = getkey();							// ޮèԔԍ擾
				}
			}
		}
		else													/* ȍĐ܂USARTgp */
		{
			SMCR = (1<<SE);										// ٓŽذߖߋ
			__sleep();											//  ذߓڍs
		}

		SMCR = 0;												// ċNŽذߖߋ֎~ݒ
	}
}

//*****************************************************************************
//*
//*	֐	: StateMachine
//*		: state : Ԕԍ, stimuli : ޮèԔԍ
//*	߂l	: nextstate : Ԕԍ
//*	ړI	: ԑJڌԔԍ擾
//*
//*****************************************************************************

unsigned char StateMachine(char state, unsigned char stimuli)
{
	unsigned char nextstate = state;							// Ԕԍ(:Ԕԍ)
	unsigned char i;											// Ɨp

	for (i=0; menu_nextstate[i].state; i++)						/* ̏ԑJڌ */
	{
		if (menu_nextstate[i].state == state && menu_nextstate[i].input == stimuli)
		{														// ԔԍONԍvȂA
			nextstate = menu_nextstate[i].nextstate;			// Ԕԍ擾
			break;												// I
		}
	}
	return nextstate;											// ԔԍƋɕA
}

//*****************************************************************************
//*
//*	֐	: Initialization
//*		: Ȃ
//*	߂l	: Ȃ
//*	ړI	: e
//*
//*****************************************************************************

void Initialization(void)
{
	char tst;													// ߂lpϐ

	OSCCAL_calibration();										// OSCCALZ
	CLKPR = (1<<CLKPCE);										// OulύXޯĐݒ
	CLKPR = (1<<CLKPS1) | (1<<CLKPS0);							// 8Ou ۯݒ(8MHz/8=1MHz)
	ACSR = (1<<ACD);											// ۸ޔr퓮֎~
	DIDR1 = (7<<ADC0D);											// ADC2`0޼ٓ͋֎~	[Bug:=DIDR0]
	PORTB = (15<<PORTB0);										// SPI֌Wޯ ٱߐݒ
	PORTE = (15<<PORTE4);										// ֌Wޯ ٱߐݒ
	sbi(DDRB, 5);												// OC1Ao͐ݒ
	sbi(PORTB, 5);												// OC1A=H
	Button_Init();												// ޮè ֌W
	RTC_init();													// RTC(/2񓯊)֌W
	Timer0_Init();												// /0(ȍĐ̑Ŏgp)
	USART_Init(12);												// 9600bpsUSART
	DF_SPI_init();												// DataFlashpSPI
	tst = Read_DF_status();										// DataFlashڼ޽l擾(޲擾)
	DF_CS_inactive;												// DataFlashIݒ
	LCD_Init();													// LCD֌W
}

//*****************************************************************************
//*
//*	֐	: BootFunc
//*		: char input (ޮèԔԍ)
//*	߂l	: char ST_state (S̏Ԕԍ)
//*	ړI	: ްė̈N̂ATmega169ؾď(vBOOTRST˭=۸(0))
//*
//*****************************************************************************

__flash char TEXT_BOOT[] = "Jump to bootloader";				//

char BootFunc(char input)
{
	static char enter = 1;										// ׸

	if(enter)													/* 񎞏 */
	{
		enter = 0;												// ׸މ
		LCD_puts_f(TEXT_BOOT, 1);								// "Jump to bootloader"LCDޯ̧ɐݒ
	}
	else if(input == KEY_ENTER)									/* ȊOON */
	{
		WDTCR = (1<<WDCE) | (1<<WDE);							// ŒZԂųޯ ϋN
		while(1);												// ؾĂ܂őҋ@(BOOTRST˭=۸(0)̂߁AؾĂްė̈s)
	}
	else if (input == KEY_PREV)									/* ȊOON */
	{
		enter = 1;												// ׸ސݒ
		return ST_OPTIONS_BOOT;									// "ްĎs"ƭԔԍƋɕA
	}
	return ST_OPTIONS_BOOT_FUNC;								// ްĎsԔԍƋɕA
}

//*****************************************************************************
//*
//*	֐	: PowerSaveFunc
//*		: char input (ޮèԔԍ)
//*	߂l	: char ST_state (S̏Ԕԍ)
//*	ړI	: ȓd͓ڍs
//*
//*****************************************************************************

__flash char TEXT_POWER[] = "Press enter to sleep";				//

char PowerSaveFunc(char input)
{
	static char enter = 1;										// ׸

	if(enter)													/* 񎞏 */
	{
		enter = 0;												// ׸މ
		LCD_puts_f(TEXT_POWER, 1);								// "Press enter to sleep"LCDޯ̧ɐݒ
	}
	else if(input == KEY_ENTER)									/* ȊOON */
	{
		PowerSave = TRUE;										// ȓd͓׸ސݒ(ʏ퓮׸މ)
		enter = 1;												// ׸ސݒ
		return ST_AVRBF;										// ƭԔԍƋɕA
	}
	else if (input == KEY_PREV)									/* ȊOON */
	{
		enter = 1;												// ׸ސݒ
		return ST_OPTIONS_POWER_SAVE;							// "ȓd͈ڍs"ƭԔԍƋɕA
	}
	return ST_OPTIONS_POWER_SAVE_FUNC;							// ȓd͈ڍsԔԍƋɕA
}

//*****************************************************************************
//*
//*	֐	: AutoPower
//*		: char input (ޮèԔԍ)
//*	߂l	: char ST_state (S̏Ԕԍ)
//*	ړI	: ȓd͓ڍsԕύX
//*
//*****************************************************************************

char AutoPower(char input)
{
	static char enter = 1;										// ׸
	char PH;													// ڍs܂ł̕Pʎ10̌
	char PL;													// ڍs܂ł̕Pʎ1̌
    
	if(enter)													/* 񎞏 */
	{
		enter = 0;												// ׸މ
        
		if(AutoPowerSave)										/* (ȓd͈ڍsON) */
		{
			PH = CHAR2BCD2(PowerSaveTimeout);					// ڍsԊu2߯BCDl擾
			PL = (PH & 0x0F) + '0';								// ڍsԊu1̌擾
			PH = (PH >> 4) + '0';								// ڍsԊu10̌擾
			LCD_putc(0, 'M');									// LCDޯ̧1'M'ݒ
			LCD_putc(1, 'I');									// LCDޯ̧2'I'ݒ
			LCD_putc(2, 'N');									// LCDޯ̧3'N'ݒ
			LCD_putc(3, ' ');									// LCDޯ̧4ɋ󔒕ݒ
			LCD_putc(4, PH);									// LCDޯ̧5ɈڍsԊu10̌ݒ
			LCD_putc(5, PL);									// LCDޯ̧6ɈڍsԊu1̌ݒ
			LCD_putc(6, '\0');									// LCDޯ̧7ɏIqݒ
			LCD_UpdateRequired(TRUE, 0);						// LCD\XVv׸ސݒ
		}
		else													/* (ȓd͈ڍsOFF) */
			LCD_puts("Off", 1);									// LCDޯ̧"Off"ݒ
	}
	else if(input == KEY_ENTER)									/* ȊOON */
	{
		enter = 1;												// ׸ސݒ
		return ST_OPTIONS_AUTO_POWER_SAVE;						// "ȓd͓ڍsԕύX"ƭԔԍƋɕA
	}
	else if (input == KEY_PLUS)									/* ȊOON */
	{
		PowerSaveTimeout += 5;									// 5PʂŎȓd͓ڍsԊuԑ
		if(PowerSaveTimeout > 90)								// 90zȂA
		{
			PowerSaveTimeout = 90;								// ől(90)ɕύX
		}
		else													// 90ȓȂA
		{    
			AutoPowerSave = TRUE;								// ȓd͈ڍs׸ސݒ
			PH = CHAR2BCD2(PowerSaveTimeout);					// ڍsԊu2߯BCDl擾
			PL = (PH & 0x0F) + '0';								// ڍsԊu1̌擾
			PH = (PH >> 4) + '0';								// ڍsԊu10̌擾
                
			LCD_putc(0, 'M');									// LCDޯ̧1'M'ݒ
			LCD_putc(1, 'I');									// LCDޯ̧2'I'ݒ
			LCD_putc(2, 'N');									// LCDޯ̧3'N'ݒ
			LCD_putc(3, ' ');									// LCDޯ̧4ɋ󔒕ݒ
			LCD_putc(4, PH);									// LCDޯ̧5ɈڍsԊu10̌ݒ
			LCD_putc(5, PL);									// LCDޯ̧6ɈڍsԊu1̌ݒ
			LCD_putc(6, '\0');									// LCDޯ̧7ɏIqݒ
			LCD_UpdateRequired(TRUE, 0);						// LCD\XVv׸ސݒ
		}
	}
	else if (input == KEY_MINUS)								/* ȊOON */
	{
		if(PowerSaveTimeout)									// ȓd͈ڍsȂA
			PowerSaveTimeout -= 5;								// 5PʂŎȓd͓ڍsԊuԌ
		if(PowerSaveTimeout < 5)								/* (ȓd͈ڍsOFF(5)) */
		{
			AutoPowerSave = FALSE;								// ȓd͈ڍsOFF׸ސݒ(ON׸މ)
			PowerSaveTimeout = 0;								// ȓd͈ڍsԊuԏ
			LCD_puts("Off", 1);									// LCDޯ̧"Off"ݒ
		}
		else													/* (ȓd͈ڍsON(5ȏ)) */
		{
			AutoPowerSave = TRUE;								// ȓd͈ڍsON׸ސݒ(OFF׸މ)
			PH = CHAR2BCD2(PowerSaveTimeout);					// ڍsԊu2߯BCDl擾
			PL = (PH & 0x0F) + '0';								// ڍsԊu1̌擾
			PH = (PH >> 4) + '0';								// ڍsԊu10̌擾
			LCD_putc(0, 'M');									// LCDޯ̧1'M'ݒ
			LCD_putc(1, 'I');									// LCDޯ̧2'I'ݒ
			LCD_putc(2, 'N');									// LCDޯ̧3'N'ݒ
			LCD_putc(3, ' ');									// LCDޯ̧4ɋ󔒕ݒ
			LCD_putc(4, PH);									// LCDޯ̧5ɈڍsԊu10̌ݒ
			LCD_putc(5, PL);									// LCDޯ̧6ɈڍsԊu1̌ݒ
			LCD_putc(6, '\0');									// LCDޯ̧7ɏIqݒ
			LCD_UpdateRequired(TRUE, 0);						// LCD\XVv׸ސݒ
		}
	}
	return ST_OPTIONS_AUTO_POWER_SAVE_FUNC;						// ȓd͓ڍsԕύXԔԍƋɕA
}

//*****************************************************************************
//*
//*	֐	: Delay
//*		: unsigned int millisec (1msPʑҋ@)
//*	߂l	: Ȃ
//*	ړI	: 1msPʑҋ@
//*
//*****************************************************************************

void Delay(unsigned int millisec)
{
	int i;														// Ɨp
    
	while (millisec--)											/* wmsҋ@ */
		for (i=0; i<125; i++);
}

//*****************************************************************************
//*
//*	֐	: Revision
//*		: char input (ޮèԔԍ)
//*	߂l	: Ȃ
//*	ړI	: ĳ Rev.ԍ\
//*
//*****************************************************************************

char Revision(char input)
{
	static char enter = 1;										// ׸
    
	if(enter)													/* 񎞏 */
	{
		enter = 0;												// ׸މ
		LCD_putc(0, 'R');										// LCDޯ̧1'R'ݒ
		LCD_putc(1, 'E');										// LCDޯ̧2'E'ݒ
		LCD_putc(2, 'V');										// LCDޯ̧3'V'ݒ
		LCD_putc(3, ' ');										// LCDޯ̧4ɋ󔒕ݒ
		LCD_putc(4, (SWHIGH + 0x30));							// LCDޯ̧5Rev.ԍ10̌ݒ
		LCD_putc(5, (SWLOW + 0x30));							// LCDޯ̧5Rev.ԍ1̌ݒ
		LCD_putc(6, '\0');										// LCDޯ̧7ɏIqݒ
		LCD_UpdateRequired(TRUE, 0);							// LCD\XVv׸ސݒ
	}
	else if (input == KEY_PREV)									/* ȊOON */
	{
		enter = 1;												// ׸ސݒ
		return ST_AVRBF;										// ƭԔԍƋɕA
	}
	return ST_AVRBF_REV;										// Rev.ԍ\ԔԍƋɕA
}

//*****************************************************************************
//*
//*	֐	: OSCCAL_calibration
//*		: Ȃ
//*	߂l	: Ȃ
//*	ړI	: O32.768kHzؽقOSCCALZ
//*
//*****************************************************************************

void OSCCAL_calibration(void)
{
	unsigned char calibrate = FALSE;							// Z׸
	int temp;													// /1vl
	unsigned char tempL;										// /1vl޲Ēl

	CLKPR = (1<<CLKPCE);										// OulύXޯĐݒ
	CLKPR = (1<<CLKPS1) | (1<<CLKPS0);							// 8Ou ۯݒ(8MHz/8=1MHz)
	TIMSK2 = 0;													// /2S荞݋֎~
	ASSR = (1<<AS2);											// /2񓯊ݒ
	OCR2A = 200;												// /2rl
	TIMSK0 = 0;													// /1S荞݋֎~
	TCCR1B = (1<<CS10);											// /1OuȂN
	TCCR2A = (1<<CS20);											// /2OuȂN
	while((ASSR & 0x01) | (ASSR & 0x04));						// /2֌Wڼ޽XV܂őҋ@
	Delay(1000);												// O32.768kHzؽٔUҋ@
	while(!calibrate)											/* Z܂ł̌p */
	{
		__disable_interrupt();									// S荞݋֎~
		TIFR1 = 0xFF;											// /1S荞ݗv׸މ
		TIFR2 = 0xFF;											// /2S荞ݗv׸މ
		TCNT1H = 0;												// /1vl
		TCNT1L = 0;
		TCNT2 = 0;												// /2vl
		while (!(TIFR2 && (1<<OCF2A)));							// 32.768kHz200ۯ(OCR2Av)܂őҋ@
		TCCR1B = 0;												// /1v~
		__enable_interrupt();									// S荞݋
		if ((TIFR1 && (1<<TOV1)))								// /1 ް۰ȂA
		{
			temp = 0xFFFF;										// /1vlƂčőlݒ	[Bug:tempt̂-1ƂĈ]
		}
		else													// /1 ް۰ȂȂA
		{
			tempL = TCNT1L;										// /1vlʎ擾
			temp = TCNT1H;										// /1vlʎ擾
			temp = (temp << 8);									// 擾ʂ޲Ĉʒuֈړ
			temp += tempL;										// /1vl擾
		}
		if (temp > 6250)										// /1vlKzȂA
		{
			OSCCAL--;											// UZl
		}
		else if (temp < 6120)									// /1vlK艺ȂA
		{
			OSCCAL++;											// UZl
		}
		else													// /1vlK͈͓ȂA
			calibrate = TRUE;									// Z׸ސݒ
		TCCR1B = (1<<CS10);										// /1Ďn
	}
}
