//***************************************************************************
//
//  ̧......: timer0.c
//  ......: ATMEL Norway
//  Ώ......: ATmega169
//  ߲....: IAR EWAAVR 2.28a
//  e......: AVR Butterfly /0 ٰ
//  Ŕԍ....: 1.0
//
//  N   - VER. - 											- 
//  20030116 - 1.0  - 쐬											- KS
//
//***************************************************************************

#include <inavr.h>
#include "iom169.h"
#include "main.h"
#include "timer0.h"

/* ϐ` */

TIMER_CALLBACK_FUNC CallbackFunc[TIMER0_NUM_CALLBACKS];				// 10msPʎso^\
char CountDownTimers[TIMER0_NUM_COUNTDOWNTIMERS];					// 10msPʌvlQ
																	// 255		: gp
																	// 254`1	: gpv
																	//   0		: gpvI

//*****************************************************************************
//*
//*	֐	: Timer0_Init
//*		: Ȃ
//*	߂l	: Ȃ
//*	ړI	: /0
//*
//*****************************************************************************

void Timer0_Init(void)
{
	char i;															// Ɨp

	for (i=0; i<TIMER0_NUM_CALLBACKS; i++)							// 10msPʎso^\S
		CallbackFunc[i] = NULL;
	for (i=0; i<TIMER0_NUM_COUNTDOWNTIMERS; i++)					// 10msPʌvlS
		CountDownTimers[i] = 255;
	// : ȍĐɂ͐mȎԂKv
	TIMSK0 = (1<<OCIE0A);											// rAv荞݋
	OCR0A = 38;														// rlݒ(10ms)
	TCCR0A = (1<<WGM01)|(0<<WGM00)|(4<<CS00);						// 256Ou,CTCŎn
}

//*****************************************************************************
//*
//*	֐	: TIMER0_COMP_interrupt
//*		: Ȃ
//*	߂l	: Ȃ
//*	ړI	: /0rA荞(10msPʂł̌vƎs̎s)
//*
//*****************************************************************************

#pragma vector = TIMER0_COMP_vect
__interrupt void TIMER0_COMP_interrupt(void)
{
	char i;															// Ɨp

	for (i=0; i<TIMER0_NUM_CALLBACKS; i++)							/* 10msPʎs */
		if (CallbackFunc[i] != NULL)								// Ήʒuo^ȂAΉss
			CallbackFunc[i]();
	for (i=0; i<TIMER0_NUM_COUNTDOWNTIMERS; i++)					/* 10msPʌv */
		if (CountDownTimers[i] != 255 && CountDownTimers[i] != 0)	// ΉʒuvlLȂA
			CountDownTimers[i]--;

}

//*****************************************************************************
//*
//*	֐	: Timer0_RegisterCallbackFunction
//*		: pFunc (sJnʒu)
//*	߂l	: /s׸
//*	ړI	: 10msPʎso^(ۂɎs邽)
//*
//*****************************************************************************

BOOL Timer0_RegisterCallbackFunction(TIMER_CALLBACK_FUNC pFunc)
{
	char i;															// Ɨp

	for (i=0; i<TIMER0_NUM_CALLBACKS; i++)							/* 10msPʎsS */
	{
		if (CallbackFunc[i] == pFunc)								// ɓo^ς݂ŐA
			return TRUE;
	}
	for (i=0; i<TIMER0_NUM_CALLBACKS; i++)							/* 10msPʎsS */
	{
		if (CallbackFunc[i] == NULL)								// 󂫈ʒuȂA
		{
			CallbackFunc[i] = pFunc;								// ΉsJnʒuo^
			return TRUE;											// A
		}
	}
	return FALSE;													// 󂫂ȂŎsA
}

//*****************************************************************************
//*
//*	֐	: Timer0_RemoveCallbackFunction
//*		: pFunc (sJnʒu)
//*	߂l	: /s׸
//*	ړI	: 10msPʎso^폜(sÎ)
//*
//*****************************************************************************

BOOL Timer0_RemoveCallbackFunction(TIMER_CALLBACK_FUNC pFunc)
{
	char i;															// Ɨp

	for (i=0; i<TIMER0_NUM_CALLBACKS; i++)							/* 10msPʎsS */
	{
		if (CallbackFunc[i] == pFunc)								// Ήo^ΉsȂA
		{
			CallbackFunc[i] = NULL;									// Ήo^ʒu(sȂݒ)
			return TRUE;											// A
		}
	}
	return FALSE;													// o^ŎsA
}

//*****************************************************************************
//*
//*	֐	: Timer0_AllocateCountdownTimer
//*		: Ȃ
//*	߂l	: 1vlԍ
//*	ړI	: 10msPʌvl蓖ėv
//*
//*****************************************************************************

char Timer0_AllocateCountdownTimer()
{
	char i;															// Ɨp

	for (i=0; i<TIMER0_NUM_COUNTDOWNTIMERS; i++)					/* 10msPʌvl */
		if (CountDownTimers[i] == 255)								// gpvlȂA
		{
			CountDownTimers[i] = 0;									// Ήvl
			return i+1;												// 1vlԍƋɕA
		}
	return 0;														// 󂫂ȂŎsA
}

//*****************************************************************************
//*
//*	֐	: Timer0_SetCountdownTimer
//*		: timer (1vlԍ), value (vl)
//*	߂l	: Ȃ
//*	ړI	: 10msPʌvllݒ
//*
//*****************************************************************************

void Timer0_SetCountdownTimer(char timer, char value)
{
	__disable_interrupt();											// S荞݋֎~
	CountDownTimers[timer-1] = value;								// Ήvllݒ
	__enable_interrupt();											// S荞݋
}

//*****************************************************************************
//*
//*	֐	: Timer0_GetCountdownTimer
//*		: timer (1vlԍ)
//*	߂l	: t (擾vl)
//*	ړI	: 10msPʌvl擾
//*
//*****************************************************************************

char Timer0_GetCountdownTimer(char timer)
{
	char t;															// vl

	__disable_interrupt();											// S荞݋֎~
	t = CountDownTimers[timer-1];									// Ήvl擾
	__enable_interrupt();											// S荞݋
	return t;
}

//*****************************************************************************
//*
//*	֐	: Timer0_ReleaseCountdownTimer
//*		: timer (1vlԍ)
//*	߂l	: Ȃ
//*	ړI	: 10msPʌvlJ
//*
//*****************************************************************************

void Timer0_ReleaseCountdownTimer(char timer)
{
	__disable_interrupt();											// S荞݋֎~
	CountDownTimers[timer-1] = 255;									// Ήvl(gpԒlݒ)
	__enable_interrupt();											// S荞݋
}

